#ifndef _TRON_H
#define _TRON_H

typedef double Ftype;

class function
{
public:
	virtual Ftype fun(Ftype *w) = 0 ;
	virtual void grad(Ftype *w, Ftype *g) = 0 ;
	virtual void Hv(Ftype *s, Ftype *Hs) = 0 ;

	virtual int get_nr_variable(void) = 0 ;
	virtual ~function(void){}
};

class TRON
{
public:
	TRON(const function *fun_obj, Ftype eps = 0.1, int max_iter = 1000);
	~TRON();

	void tron(Ftype *w);

private:
	int trcg(Ftype delta, Ftype *g, Ftype *s, Ftype *r);
	Ftype norm_inf(int n, Ftype *x);

	Ftype eps;
	int max_iter;
	function *fun_obj;
};

#endif
