#!/usr/bin/env python
from parameter import *
from parse_digit import *
import sys
import os
from os import system

data = ['a9a','real-sim','ijcnn','mnist','covtype']
methodlist = ["poly2expand","poly2"]
print """
\\begin{tabular}{@{}l|r|rr|rr@{}}	
	\\multirow{2}{*}{Data set}
  & \\multirow{2}{*}{$\\hat{n} / \\bar{n}$}
	& \\multicolumn{2}{|c}{Storing $\\phi(\\bx_i)$} 
	& \\multicolumn{2}{|c}{Calculating $\\phi(\\bx_i)$} \\\\
	& & L2 cache miss & Training time & L2 cache miss & Training time \\\\
	\\hline
"""
for d in data:
	o = []
	dp = path + data_path[d]
	log_data = log_path + d + '.' + 'count' + '.log'
	try:
		tmp_data = open('%s'%log_data,'r').readlines()
	except:
		system('%s %s > %s'%(count_exe,dp,log_data))
		tmp_data = open('%s'%log_data,'r').readlines()
	ratio = float(tmp_data[2].split(' ')[1].strip())/float(tmp_data[0].split(' ')[1].strip())
	digit =  FormatWithCommas('%.2f', ratio)
	o.append(digit);
	for method in methodlist:
		dp = log_path + d + '.cachegrind.' + method + '.log'
		if 'webspam' in d or 'covtype' in d:
			o.append('NA')
		else:
			try:
				tmp_data = open(dp,'r').readlines()
			except:
				if method == "poly2expand":
					traindata = path + data_path[d]
					expanddata = expand_path + d + '.' + str(best_quad_g[d]) + 'g'
					try:
						os.stat(expanddata)
					except:
						cmd = "%s %s %s %s 1"%(expand_exe,traindata,expanddata,best_quad_g[d])
						system(cmd)
					model = model_path + "tmpmodel"
					cmd = "time valgrind --tool=cachegrind %s -c %s -s 3 -B -1 %s %s 2>%s"%(linear_train_exe, best_quad_c[d],expanddata,model,dp)
					system(cmd)

				if method == "poly2":
					traindata = path + data_path[d]
					model = model_path + "tmpmodel"
					cmd = "time valgrind --tool=cachegrind %s -c %s -g %s -r 1 -s 3 -B -1 %s %s 2>%s"%(poly2_train_exe,best_quad_c[d],best_quad_g[d],traindata,model,dp)
					system(cmd)
				tmp_data = open(dp,'r').readlines()
			for l in tmp_data:
				if 'L2 misses' in l:
					misses = float(l.split()[3].replace(',',''))
					digit = "%.2e"%(misses)
					o.append(digit)
					break		
		dp = log_path + d + '.' + method + '.log'
		try:
			tmp_data = open(dp,'r').readlines()
		except:
			if method == "poly2expand":
				traindata = path + data_path[d]
				expanddata = expand_path + d + '.' + str(best_quad_g[d]) + 'g'
				try:
					os.stat(expanddata)
				except:
					cmd = "%s %s %s %s 1"%(expand_exe,traindata,expanddata,best_quad_g[d])
					system(cmd)
				model = model_path + "tmpmodel"
				cmd = "time %s -c %s -s 3 -B -1 %s %s >> %s"%(linear_train_exe, best_quad_c[d],expanddata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			if method == "poly2":
				traindata = path + data_path[d]
				model = model_path + d
				testdata = path + test_path[d]
				cmd = "time %s -c %s -g %s -r 1 -s 3 -B -1 %s %s >> %s"%(poly2_train_exe,best_quad_c[d],best_quad_g[d], traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
				cmd = "time %s %s %s tmp_file >> %s"%(poly2_predict_exe,testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			tmp_data = open(dp,'r').readlines()

		for l in tmp_data:
			if '=== time' in l:
				time = float(l.split(' ')[2].strip())				
				digit =  FormatWithCommas('%.1f', time)
				o.append(digit)
				break
	if "webspam" in d:	
		print "%s\\footnotemark & %s & %s & %s & %s & %s \\\\"%(output_name[d],o[0],o[1],o[2],o[3],o[4])
	else:
		print "%s & %s & %s & %s & %s & %s \\\\"%(output_name[d],o[0],o[1],o[2],o[3],o[4])
print "\\end{tabular}"
