#!/usr/bin/env python
from parameter import *
from parse_digit import *
from os import system

methodlist = ["poly2","poly2libsvm.m1000","linear","rbf.m1000"]
print """
\\begin{tabular}{@{}l|rrrrr|rr@{}}	
\\multirow{3}{*}{Data set} &	\\multicolumn{5}{|c}{Degree-2 Polynomial} & \\multicolumn{2}{|c}{Accuracy diff.} \\\\
	& \\multirow{2}{*}{$C$} & \\multirow{2}{*}{$\\gamma$} & 
\\multicolumn{2}{c}{Time} & \\multirow{2}{*}{Accuracy} & \\multirow{2}{*}{linear} & \\multirow{2}{*}{RBF} \\\\
 & & & \\liblinear & \\libsvm & & &\\\\
\\hline
"""

for d in data:
	o = []
	time = {}
	acc = {}
	for method in methodlist:
		dp = log_path + d + '.' + method + '.log'		
		try:
			tmp_data = open(dp,'r').readlines()
		except:
			traindata = path + data_path[d]
			model = model_path + d + '.' + method + '.model'
			testdata = path + test_path[d]
			if method == "linear":
				cmd = "time %s -c %s -s 3 -B -1 %s %s >> %s"%(linear_train_exe, best_lin_c[d],traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)
				cmd = "time %s %s %s tmp_file >> %s"%(linear_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "rbf.m1000":
				cmd = "time %s -m 1000 -c %s -g %s -e 0.1  %s %s >> %s"%(libsvm_train_exe, best_rbf_c[d],best_rbf_g[d], traindata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)				
				cmd = "time %s %s %s tmp_file >> %s"%(libsvm_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "poly2libsvm.m1000":
				cmd = "time %s -m 1000 -t 1 -d 2 -r 1 -c %s -g %s -e 0.1  %s %s >> %s"%(libsvm_train_exe,best_quad_c[d],best_quad_g[d], traindata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)				
				cmd = "time %s %s %s tmp_file >> %s"%(libsvm_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "poly2":
				cmd = "time %s -c %s -g %s -r 1 -s 3 -B -1 %s %s >> %s"%(poly2_train_exe,best_quad_c[d],best_quad_g[d], traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)
				cmd = "time %s %s %s tmp_file >> %s"%(poly2_predict_exe,testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			tmp_data = open(dp,'r').readlines()
		for l in tmp_data:
			if 'train' in l and method == "poly2":
				t = l.split(' ')
				for i in range(len(t)):
					if t[i] == '-c':
						c = (t[i+1].strip())
						digit = "%s"%(c)
						o.append(digit)
					if t[i] == '-g':
						g = (t[i+1].strip())
						digit = "%s"%(g)
						o.append(digit)
			elif '=== time' in l:
				time[method] = l.split(' ')[2].strip()
				if "poly2" in method:
					if 'NA' in time[method]:
						digit = 'NA'
					else:
						digit = FormatWithCommas("%5.1f",float(time[method]))
					o.append(digit)
			elif 'Accuracy' in l:
				acc[method] = l.split(' ')[2].strip().strip('%')				

	digit = "%5.2f"%float(acc["poly2"])
	o.append(digit)
	digit = "%5.2f"%(float(acc["poly2"])-float(acc['linear']))	
	o.append(digit)
	digit = "%5.2f"%(float(acc["poly2"])-float(acc['rbf.m1000']))	
	o.append(digit)

	print "%s & %s & %s & %s & %s & %s & %s & %s\\\\"%(output_name[d],o[0],o[1],o[2],o[3],o[4],o[5],o[6])
print "\\end{tabular}"
