#!/usr/bin/env python
from parameter import *
from parse_digit import *
import math
import sys
import os
from os import system

methodlist = ["linear-l1","poly2-l1","poly2expand-l1"]
print """
\\begin{tabular}{@{}l|r@{\\hspace{0.25cm}}r@{\\hspace{0.25cm}}r|r@{\\hspace{0.25cm}}r@{\\hspace{0.25cm}}r@{\\hspace{0.25cm}}r|r@{}} 
& \\multicolumn{3}{c|}{Linear} & \\multicolumn{4}{c}{Degree-2 polynomial} & \\\\
\\multirow{2}{*}{Data set} & \\multirow{2}{*}{Time} & Sparsity 
& Accuracy & \\multicolumn{2}{c}{Time: $\\phi(\\bx_i)$ is} & Sparsity & Accuracy & L2 SVM \\\\
 & & (\\%) & (\\%) & stored & calculated & (\\%) & (\\%) & Sparsity \\\\
\\hline
"""
for d in data:
	o = []
	time = {}
	acc = {}
	nonzero = {}
	nfeat = {}
	for method in methodlist:
		dp = log_path + d + '.' + method + '.log'		
		try:
			tmp_data = open(dp,'r').readlines()
		except:
			traindata = path + data_path[d]
			model = model_path + d + '.' + method + '.model'
			testdata = path + test_path[d]
			if method == "linear-l1":
				cmd = "time %s -c %s -e 0.01 -s 5 -B -1 %s %s >> %s"%(linear_train_exe, best_l1_lin_c[d],traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)
				cmd = "time %s %s %s tmp_file >> %s"%(linear_predict_exe, testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)

			if method == "poly2-l1":
				cmd = "time %s -c %s -g %s -r 1 -e 0.01 -s 5  -B -1 %s %s >> %s"%(poly2_train_exe,best_l1_quad_c[d],best_l1_quad_g[d], traindata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				print cmd
				system(cmd)
				cmd = "time %s %s %s tmp_file >> %s"%(poly2_predict_exe,testdata, model, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			if method == "poly2expand-l1":
				traindata = path + data_path[d]
				expanddata = expand_path + d + '.' + str(best_l1_quad_g[d]) + 'g'
				try:
					os.stat(expanddata)
				except:
					cmd = "%s %s %s %s 1"%(expand_exe,traindata,expanddata,best_l1_quad_g[d])
					system(cmd)
				testdata = path + test_path[d]
				model = model_path + "tmpmodel"
				newmodel_name = model + '.new'
				cmd = "time %s -c %s -s 5 -e 0.01 -B -1 %s %s >> %s"%(linear_train_exe, best_l1_quad_c[d],expanddata,model,dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
				data = open(model).readlines()
				for ind in range(len(data)):
					if 'nr_feature' in data[ind]:
						w_size = int(data[ind].strip().split(' ')[1])
						n = (-3 + math.sqrt(9+4*(2*w_size-2)))/2
						data[ind] = 'nr_feature %s\n'%int(n)
				newmodel = open(model+'.new','w')
				newmodel.write('coef0 1\ngamma %s\n'%best_l1_quad_g[d])
				newmodel.write("".join(data))
				newmodel.close()
				cmd = "time %s %s %s tmp_file >> %s"%(poly2_predict_exe,testdata, newmodel_name, dp)
				system('echo \'%s\' >> %s'%(cmd, dp))
				system(cmd)
			tmp_data = open(dp,'r').readlines()

		for l in tmp_data:
			if 'Accuracy' in l and "expand" not in method:
				acc[method] = l.split(' ')[2].strip().strip('%')	
			elif '=== time' in l:
				time[method] = l.split(' ')[2].strip()
			elif "nonzeros" in l and "expand" not in method:
				nonzero[method] = l.split(' ')[2].split('/')[0]
				nfeat[method] = l.split(' ')[2].split('/')[1]
	digit = "%5.2f"%float(time["linear-l1"])
	o.append(digit)
	digit = "%5.2f"%(100*float(nonzero["linear-l1"])/float(nfeat["linear-l1"]))
	o.append(digit)
	digit = "%5.2f"%float(acc["linear-l1"])
	o.append(digit)
	digit = FormatWithCommas('%5.2f', float(time["poly2expand-l1"]))
	o.append(digit)
	digit = FormatWithCommas('%5.2f', float(time["poly2-l1"]))
	o.append(digit)
	digit = "%5.2f"%(100*float(nonzero["poly2-l1"])/float(nfeat["poly2-l1"]))
	o.append(digit)
	digit = "%5.2f"%float(acc["poly2-l1"])
	o.append(digit)
	"""
	digit = "%5.2f"%float(acc["poly2"])
	o.append(digit)
	digit = "%5.2f"%(float(acc["poly2"])-float(acc['linear']))	
	o.append(digit)
	digit = "%5.2f"%(float(acc["poly2"])-float(acc['rbf.m1000']))	
	o.append(digit)

	"""
	print "%s & %s & %s & %s & %s & %s & %s & %s\\\\"%(output_name[d],o[0],o[1],o[2],o[3],o[4],o[5],o[6])
	
print "\\end{tabular}"
